VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "MagicWand"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit

Dim undoch As Changes
Dim parent As frmMain

Sub setParent(main As frmMain)
    Set parent = main
End Sub

Sub MouseDown(Button As Integer, Shift As Integer, x As Single, y As Single)
    Dim curtilex As Integer
    Dim curtiley As Integer
    On Error GoTo MouseDown_Error

    curtilex = (Int(((parent.hScr.value + x)) / (parent.currenttilew)))
    curtiley = (Int(((parent.vScr.value + y)) / (parent.currenttilew)))

    If (curtilex < 0 Or curtiley < 0 Or curtilex > 1023 Or curtiley > 1023) Then
        Exit Sub
    End If

    Dim sourcetilenr As Integer
    If parent.sel.getIsInSelection(curtilex, curtiley) Then
        sourcetilenr = parent.sel.getSelTile(curtilex, curtiley)
    Else
        sourcetilenr = parent.getTile(curtilex, curtiley)
    End If


    If parent.sel.selstate = append Then
        If Button = vbRightButton Or _
           Button = vbLeftButton And parent.sel.getIsInSelection(curtilex, curtiley) And ((parent.pastetype <> p_normal And parent.sel.getSelTile(curtilex, curtiley) <> 0) Or parent.pastetype = p_normal) And _
           Shift <> 1 And Shift <> 2 Then
            Call parent.sel.MouseDown(Button, Shift, x, y)
            Exit Sub
        End If
    End If

    If Button = vbRightButton Then Exit Sub

    If Shift = 2 Then
        If parent.sel.getIsInSelection(curtilex, curtiley) Then
            Call Regions(False, sourcetilenr, curtilex, curtiley, parent.fillinscreen)
        End If
    ElseIf Shift = 1 Then
        If Not parent.sel.getIsInSelection(curtilex, curtiley) Then
            Call Regions(True, sourcetilenr, curtilex, curtiley, parent.fillinscreen)
        End If
        parent.sel.selstate = append
    Else
        Call parent.sel.ApplySelection
        Call Regions(True, sourcetilenr, curtilex, curtiley, parent.fillinscreen)
        parent.sel.selstate = append
    End If

    On Error GoTo 0
    Exit Sub

MouseDown_Error:

    MsgBox "Error " & Err.Number & " (" & Err.Description & ") in procedure MouseDown of Class Module Bucket"
End Sub

Sub MouseMove(Button As Integer, Shift As Integer, x As Single, y As Single)
    Dim curtilex As Integer
    Dim curtiley As Integer
    curtilex = (Int(((parent.hScr.value + x)) / (parent.currenttilew)))
    curtiley = (Int(((parent.vScr.value + y)) / (parent.currenttilew)))

    If (curtilex < 0 Or curtiley < 0 Or curtilex > 1023 Or curtiley > 1023) Then
        Exit Sub
    End If

    If parent.sel.hasAlreadySelectedParts And parent.sel.getIsInSelection(curtilex, curtiley) And ((parent.pastetype <> p_normal And parent.sel.getSelTile(curtilex, curtiley) <> 0) Or parent.pastetype = p_normal) And _
       Shift <> 1 And Shift <> 2 Then
        parent.picpreview.MousePointer = 5
    Else
        parent.picpreview.MousePointer = 99
    End If

    If SharedVar.MouseDown And parent.sel.selstate = append Then
        Call parent.sel.MouseMove(Button, Shift, x, y)
    End If
End Sub

Sub MouseUp(Button As Integer, Shift As Integer, x As Single, y As Single)
    If parent.sel.selstate = append Then
        Call parent.sel.MouseUp(Button, Shift)
    End If

End Sub

Sub Regions(add As Boolean, tilenr As Integer, ByVal x As Integer, ByVal y As Integer, Optional fillscreenonly = True, Optional ByVal stack As Long = 50000)

    On Error GoTo Fill_Error

    parent.MousePointer = vbHourglass

    Dim done(1023, 1023) As Boolean
    Dim px() As Long
    Dim py() As Long
    Dim Pstart As Long
    Dim Pstop As Long
    Dim Pcount As Long
    Dim Colour As Integer

    Dim Lx As Integer
    Dim Ly As Integer

    Dim Sloop As Long
    ReDim px(0)
    ReDim py(0)

    Lx = x
    Ly = y

    Pstart = 0
    Pstop = 0
    px(0) = Lx
    py(0) = Ly
    Dim count As Long

    Dim lbsx As Integer
    Dim lbsy As Integer
    Dim hbsx As Integer
    Dim hbsy As Integer
    lbsx = Int(parent.hScr.value / (parent.currenttilew))
    hbsx = Int((parent.hScr.value + parent.picpreview.Width) / (parent.currenttilew))
    lbsy = Int(parent.vScr.value / (parent.currenttilew))
    hbsy = Int((parent.vScr.value + parent.picpreview.Height) / (parent.currenttilew))

    GoSub AddPoints
    While Pstart < Pstop

        Lx = px(Pstart)
        Ly = py(Pstart)
        If Not (Lx < 0 Or Ly < 0 Or Lx > 1023 Or Ly > 1023) Then
            If fillscreenonly Then
                If (Lx < lbsx Or Ly < lbsy Or Lx > hbsx Or Ly > hbsy) Then
                    GoTo skiploop
                End If
            End If

            If parent.sel.getIsInSelection(Lx, Ly) Then
                Colour = parent.sel.getSelTile(Lx, Ly)
            Else
                Colour = parent.getTile(Lx, Ly)
            End If

            If Not (done(Lx, Ly) = True Or Colour <> tilenr) Then
                Pcount = Pcount + 1
                done(Lx, Ly) = True

                count = count + 1

                If add Then
                    If Not parent.sel.getIsInSelection(Lx, Ly) Then
                        Call parent.sel.AddSelectionArea(Lx, Lx, Ly, Ly, False)
                    End If
                Else
                    If parent.sel.getIsInSelection(Lx, Ly) Then
                        Call parent.sel.RemoveSelectionArea(Lx, Lx, Ly, Ly, False)
                    End If

                End If

                GoSub AddPoints
            End If
        End If
skiploop:
        Pstart = Pstart + 1

    Wend

    If Not add Then
        parent.sel.hasAlreadySelectedParts = parent.sel.areThereTilesInSelection
    End If

    Call frmGeneral.UpdateToolbarButtons
    Call parent.UpdateLevel

    parent.MousePointer = 0
    Exit Sub

AddPoints:

    If Pstart > stack Then
        For Sloop = Pstart To Pstop
            px(Sloop - stack) = px(Sloop)
            py(Sloop - stack) = py(Sloop)
        Next Sloop
        ReDim Preserve px(Pstop - stack)
        ReDim Preserve py(Pstop - stack)
        Pstart = Pstart - stack
        Pstop = Pstop - stack
    End If
    ReDim Preserve px(Pstop + 4)
    ReDim Preserve py(Pstop + 4)
    Pstop = Pstop + 1
    px(Pstop) = Lx + 1
    py(Pstop) = Ly
    Pstop = Pstop + 1
    px(Pstop) = Lx
    py(Pstop) = Ly + 1
    Pstop = Pstop + 1
    px(Pstop) = Lx - 1
    py(Pstop) = Ly
    Pstop = Pstop + 1
    px(Pstop) = Lx
    py(Pstop) = Ly - 1

    Return
    '~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~


    On Error GoTo 0
    Exit Sub

Fill_Error:

    MsgBox "Error " & Err.Number & " (" & Err.Description & ") in procedure Fill of Class Module Bucket"

End Sub

