VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "Pencil"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit

Dim oldpenciltilex As Integer
Dim oldpenciltiley As Integer
Dim parent As frmMain

Dim undoch As Changes

Dim usewalltile As Boolean

Sub setParent(main As frmMain)
    Set parent = main
End Sub

Sub MouseDown(Button As Integer, x As Single, y As Single)
    Dim curtilex As Integer
    Dim curtiley As Integer
    On Error GoTo MouseDown_Error

    curtilex = (Int(((parent.hScr.value + x)) / (parent.currenttilew)))
    curtiley = (Int(((parent.vScr.value + y)) / (parent.currenttilew)))
    If (curtilex < 0 Or curtiley < 0 Or curtilex > 1023 Or curtiley > 1023) Then
        Exit Sub
    End If


    parent.undoredo.ResetRedo
    Set undoch = New Changes

    oldpenciltilex = curtilex
    oldpenciltiley = curtiley

    Dim tmptile As Integer
    Dim tmpTileSizeX As Integer
    Dim tmpTileSizeY As Integer

    If curtool = T_Eraser Then
        tmptile = 0
        tmpTileSizeX = 1
        tmpTileSizeY = 1
        usewalltile = False
        parent.tline.usewalltile = False
    Else
        If Button = vbLeftButton Then
            tmptile = parent.tilesetleft
            tmpTileSizeX = parent.multTileLeftx
            tmpTileSizeY = parent.multTileLefty
            usewalltile = parent.useWallTileLeft
            parent.walltiles.curwall = parent.curWallTileLeft
            parent.tline.usewalltile = parent.useWallTileLeft
        ElseIf Button = vbRightButton Then
            tmptile = parent.tilesetright
            tmpTileSizeX = parent.multTileRightx
            tmpTileSizeY = parent.multTileRighty
            usewalltile = parent.useWallTileRight
            parent.walltiles.curwall = parent.curWallTileRight
        End If
        parent.tline.usewalltile = usewalltile
    End If

    If usewalltile Then
        Call parent.walltiles.ClearIsWallTile
    End If

    If tmptile = 217 Or tmptile = 219 Or _
       tmptile = 220 Then
        Call setObject(parent, tmptile, curtilex - GetMaxSizeOfObject(tmptile) \ 2, curtiley - GetMaxSizeOfObject(tmptile) \ 2, undoch)
    Else


        Dim i As Integer
        Dim j As Integer
        If tmpTileSizeX > 1 Or tmpTileSizeY > 1 Then
            Call MouseMove(Button, x, y)
        Else
            If parent.tline.linew <> 1 Then
                For j = -Int(parent.tline.linew / 2) + 1 To Int(parent.tline.linew / 2)
                    For i = -Int(parent.tline.linew / 2) + 1 To Int(parent.tline.linew / 2)
                        If curtilex + i >= 0 And curtilex + i <= 1023 And curtiley + j >= 0 And curtiley + j <= 1023 Then
                            If parent.pastetype <> p_under Or curtool = T_Eraser Or _
                               parent.pastetype = p_under And parent.getTile(curtilex + i, curtiley + j) = 0 Then
                                If isTileSpecial(parent, curtilex, curtiley) Then
                                    Call SearchAndDestroyObject(parent, curtilex, curtiley, undoch)
                                End If

                                If usewalltile Then
                                    tmptile = parent.walltiles.DrawWallTile(curtilex + i, curtiley + j, True, undoch)
                                End If
                                Call parent.setTile(curtilex + i, curtiley + j, tmptile, undoch)
                                Call parent.UpdateLevelTile(curtilex + i, curtiley + j, False)
                            End If
                        End If
                    Next
                Next

                If usewalltile Then
                    'repeat the process if using walltiles to make sure all tiles are correct
                    For j = -Int(parent.tline.linew / 2) + 1 To Int(parent.tline.linew / 2)
                        For i = -Int(parent.tline.linew / 2) + 1 To Int(parent.tline.linew / 2)
                            If curtilex + i >= 0 And curtilex + i <= 1023 And curtiley + j >= 0 And curtiley + j <= 1023 Then
                                If parent.pastetype <> p_under Or _
                                   parent.pastetype = p_under And parent.getTile(curtilex + i, curtiley + j) = 0 Then
                                    If usewalltile Then
                                        tmptile = parent.walltiles.DrawWallTile(curtilex + i, curtiley + j, True, undoch, False)
                                    End If
                                    Call parent.setTile(curtilex + i, curtiley + j, tmptile, undoch)
                                    Call parent.UpdateLevelTile(curtilex + i, curtiley + j, False)
                                End If
                            End If
                        Next
                    Next
                End If
            Else
                If curtilex + i >= 0 And curtilex + i <= 1023 And curtiley + j >= 0 And curtiley + j <= 1023 Then
                    If parent.pastetype <> p_under Or _
                       parent.pastetype = p_under And parent.getTile(curtilex, curtiley) = 0 Then
                        If isTileSpecial(parent, curtilex, curtiley) Then
                            Call SearchAndDestroyObject(parent, curtilex, curtiley, undoch)
                        End If

                        If usewalltile Then
                            Call parent.walltiles.ClearIsWallTile
                            Call parent.walltiles.setIsWallTile(curtilex, curtiley)
                            tmptile = parent.walltiles.DrawWallTile(curtilex, curtiley, True, undoch, False)
                        End If
                        Call parent.setTile(curtilex, curtiley, tmptile, undoch)
                        Call parent.UpdateLevelTile(curtilex, curtiley, False)
                    End If
                End If
            End If
        End If

        If parent.magnifier.UsingPixels Then
            parent.UpdateLevel
        Else
            parent.UpdatePreview
        End If
    End If
    parent.mapchanged = True

    Call parent.walltiles.ClearIsWallTile

    On Error GoTo 0
    Exit Sub

MouseDown_Error:

    MsgBox "Error " & Err.Number & " (" & Err.Description & ") in procedure MouseDown of Class Module Pencil"
End Sub

Sub MouseMove(Button As Integer, x As Single, y As Single)
    Dim curtilex As Integer
    Dim curtiley As Integer

    On Error GoTo MouseMove_Error

    curtilex = (Int(((parent.hScr.value + x)) / (parent.currenttilew)))
    curtiley = (Int(((parent.vScr.value + y)) / (parent.currenttilew)))

    If curtilex < 0 Then curtilex = 0
    If curtiley < 0 Then curtiley = 0
    If curtilex > 1023 Then curtilex = 1023
    If curtiley > 1023 Then curtiley = 1023

    Dim tmptile As Integer
    Dim tmpTileSizeX As Integer
    Dim tmpTileSizeY As Integer

    If curtool = T_Eraser Then
        tmptile = 0
        tmpTileSizeX = 1
        tmpTileSizeY = 1
        usewalltile = False
    Else
        If Button = vbLeftButton Then
            tmptile = parent.tilesetleft
            tmpTileSizeX = parent.multTileLeftx
            tmpTileSizeY = parent.multTileLefty
            usewalltile = parent.useWallTileLeft
            parent.walltiles.curwall = parent.curWallTileLeft
        ElseIf Button = vbRightButton Then
            tmptile = parent.tilesetright
            tmpTileSizeX = parent.multTileRightx
            tmpTileSizeY = parent.multTileRighty
            usewalltile = parent.useWallTileRight
            parent.walltiles.curwall = parent.curWallTileRight
        End If
    End If
    If usewalltile Then
        Call parent.walltiles.ClearIsWallTile
    End If
    parent.tline.usewalltile = usewalltile

    If SharedVar.MouseDown Then
        If tmptile = 217 Or tmptile = 219 Or _
           tmptile = 220 Then
            'Call setObject(parent, tmptile, curtilex, curtiley, undoch)
            'Don't draw special objects on mousemove
            'Exit Sub
        Else
            'draw a line from the old x,y s
            'its more fluent
            If oldpenciltilex >= 0 And oldpenciltilex < 1024 And _
               oldpenciltiley >= 0 And oldpenciltiley < 1024 Then

                If usewalltile Then
                    Call parent.tline.DrawLine(tmptile, oldpenciltilex, oldpenciltiley, curtilex, curtiley, undoch, tmpTileSizeX, tmpTileSizeY, False, False, , , , True)
                End If
                Call parent.tline.DrawLine(tmptile, oldpenciltilex, oldpenciltiley, curtilex, curtiley, undoch, tmpTileSizeX, tmpTileSizeY, False, False)
            End If
        End If

        If parent.magnifier.UsingPixels Then
            parent.UpdateLevel
        Else
            parent.UpdatePreview
        End If
    End If

    If Not parent.magnifier.UsingPixels And Not SharedVar.MouseDown And (curtool = T_pencil Or curtool = T_Eraser) Then
        'Draw the preview tile
        'only if pencil has moved
        If curtilex <> oldpenciltilex Or curtiley <> oldpenciltiley Then
            If curtool = T_Eraser Then
                tmptile = 0
                usewalltile = False
            Else
                If parent.lastbutton = vbLeftButton Then
                    tmptile = parent.tilesetleft
                    tmpTileSizeX = parent.multTileLeftx
                    tmpTileSizeY = parent.multTileLefty
                    usewalltile = parent.useWallTileLeft
                    parent.walltiles.curwall = parent.curWallTileLeft
                ElseIf parent.lastbutton = vbRightButton Then
                    tmptile = parent.tilesetright
                    tmpTileSizeX = parent.multTileRightx
                    tmpTileSizeY = parent.multTileRighty
                    usewalltile = parent.useWallTileRight
                    parent.walltiles.curwall = parent.curWallTileRight
                Else
                    tmptile = parent.tilesetleft
                    tmpTileSizeX = parent.multTileLeftx
                    tmpTileSizeY = parent.multTileLefty
                    usewalltile = parent.useWallTileLeft
                    parent.walltiles.curwall = parent.curWallTileLeft
                End If
            End If
            Dim lbx As Integer
            Dim lby As Integer

            lbx = parent.hScr.value \ parent.currenttilew
            lby = parent.vScr.value \ parent.currenttilew
            If tmptile = 217 Then
                SetStretchBltMode parent.picpreview.hdc, HALFTONE
                StretchBlt parent.picpreview.hdc, (curtilex - lbx) * (parent.currenttilew), (curtiley - lby) * (parent.currenttilew), 2 * (parent.currenttilew), 2 * (parent.currenttilew), frmGeneral.picspecial.hdc, 16, 0, 2 * TileW, 2 * TileW, vbSrcCopy
                parent.picpreview.refresh
            ElseIf tmptile = 219 Then
                SetStretchBltMode parent.picpreview.hdc, HALFTONE
                StretchBlt parent.picpreview.hdc, (curtilex - lbx - 2) * (parent.currenttilew), (curtiley - lby - 2) * (parent.currenttilew), 6 * (parent.currenttilew), 6 * (parent.currenttilew), frmGeneral.picspecial.hdc, 128, 0, 6 * TileW, 6 * TileW, vbSrcCopy
                parent.picpreview.refresh
            ElseIf tmptile = 220 Then
                SetStretchBltMode parent.picpreview.hdc, HALFTONE
                StretchBlt parent.picpreview.hdc, (curtilex - lbx - 2) * (parent.currenttilew), (curtiley - lby - 2) * (parent.currenttilew), 5 * (parent.currenttilew), 5 * (parent.currenttilew), frmGeneral.picspecial.hdc, 48, 0, 5 * TileW, 5 * TileW, vbSrcCopy
                parent.picpreview.refresh
            Else
                If usewalltile Then
                    Call parent.walltiles.ClearIsWallTile
                    Call parent.tline.DrawLine(tmptile, curtilex, curtiley, curtilex, curtiley, undoch, tmpTileSizeX, tmpTileSizeY, True, True, False, , , True)
                End If
                Call parent.tline.DrawLine(tmptile, curtilex, curtiley, curtilex, curtiley, undoch, tmpTileSizeX, tmpTileSizeY, True, True, False, , , False)
            End If
            Call parent.UpdatePreview(False)
        End If
    End If
    oldpenciltilex = curtilex
    oldpenciltiley = curtiley

    On Error GoTo 0
    Exit Sub

MouseMove_Error:

    MsgBox "Error " & Err.Number & " (" & Err.Description & ") in procedure MouseMove of Class Module Pencil"
End Sub

Sub MouseUp()
'do nothing
    On Error GoTo MouseUp_Error

    Call parent.undoredo.AddToUndo(undoch)
    'for tile 0 being gridded again we need to update the level
    Call parent.UpdateLevel

    On Error GoTo 0
    Exit Sub

MouseUp_Error:

    MsgBox "Error " & Err.Number & " (" & Err.Description & ") in procedure MouseUp of Class Module Pencil"

End Sub


