VERSION 5.00
Object = "{48E59290-9880-11CF-9754-00AA00C00908}#1.0#0"; "MSINET.OCX"
Begin VB.Form frmCheckUpdate 
   BorderStyle     =   3  'Fixed Dialog
   Caption         =   "Checking for updates"
   ClientHeight    =   2595
   ClientLeft      =   165
   ClientTop       =   465
   ClientWidth     =   4650
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   173
   ScaleMode       =   3  'Pixel
   ScaleWidth      =   310
   ShowInTaskbar   =   0   'False
   StartUpPosition =   3  'Windows Default
   Begin VB.CommandButton cmdRecheck 
      Caption         =   "Recheck"
      Height          =   375
      Left            =   1800
      TabIndex        =   5
      Top             =   2160
      Width           =   1095
   End
   Begin VB.CommandButton cmdUpdate 
      Caption         =   "Update"
      Enabled         =   0   'False
      Height          =   375
      Left            =   120
      TabIndex        =   3
      Top             =   2160
      Width           =   1215
   End
   Begin VB.CommandButton cmdCancel 
      Caption         =   "Cancel"
      Height          =   375
      Left            =   3360
      TabIndex        =   2
      Top             =   2160
      Width           =   1215
   End
   Begin InetCtlsObjects.Inet inet 
      Left            =   0
      Top             =   1440
      _ExtentX        =   1005
      _ExtentY        =   1005
      _Version        =   393216
      Protocol        =   4
      URL             =   "http://"
   End
   Begin VB.Label lblUpdateDownloaded 
      Caption         =   "Update Downloaded"
      Height          =   375
      Left            =   1080
      TabIndex        =   6
      Top             =   1320
      Width           =   2775
   End
   Begin VB.Label lblstatus 
      BeginProperty Font 
         Name            =   "MS Sans Serif"
         Size            =   9.75
         Charset         =   0
         Weight          =   700
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   255
      Left            =   1080
      TabIndex        =   4
      Top             =   1800
      Width           =   3015
   End
   Begin VB.Label lblRetrievingUpdateInfo 
      Caption         =   "Retrieving update (info)"
      Height          =   375
      Left            =   1080
      TabIndex        =   1
      Top             =   840
      Width           =   2775
   End
   Begin VB.Label lblconnect 
      Caption         =   "Connecting to server"
      Height          =   255
      Left            =   1080
      TabIndex        =   0
      Top             =   360
      Width           =   2535
   End
   Begin VB.Image imgarrow 
      Height          =   330
      Left            =   240
      Picture         =   "frmCheckUpdate.frx":0000
      Top             =   300
      Width           =   330
   End
End
Attribute VB_Name = "frmCheckUpdate"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

Dim version As String
Dim updateurl As String

Private Sub cmdCancel_Click()
    Unload Me
End Sub

Private Sub cmdRecheck_Click()
    CheckUpdate
End Sub

Private Sub cmdUpdate_Click()
    Dim filetitle As String
    Dim parts() As String
    parts = Split(updateurl, "/")
    filetitle = parts(UBound(parts))
    
    lblRetrievingUpdateInfo.Caption = "Retrieving Update"
    
    Call HTTPDownloadFile(inet, updateurl, App.path & "\" & filetitle)
    
    imgarrow.Top = lblUpdateDownloaded.Top - 4
    DoEvents
    
    MsgBox "Update is downloaded to DCME directory, close this DCME and extract the new file from the update", vbOKOnly + vbInformation
    
    Unload Me
    
End Sub

Private Sub Form_Load()
    Set Me.Icon = frmGeneral.Icon
    
        DoEvents
    frmCheckUpdate.CheckUpdate

End Sub

Private Sub Form_QueryUnload(Cancel As Integer, UnloadMode As Integer)
'If we press X, then do cancel
    cmdCancel_Click
End Sub

Sub CheckUpdate()
        imgarrow.Top = lblconnect.Top - 4
        
        Dim str As String
        
        str = GetHTTPFile(inet, "http://www.student.kuleuven.ac.be/~s0158884/DCME/dcmeupdate.txt")
        
        Dim lines() As String
        lines = Split(str, Chr(10))
        
        Dim i As Integer
        
        For i = LBound(lines) To UBound(lines)
            Dim parts() As String
            parts() = Split(lines(i), "=")
            
            If parts(0) = "version" Then
                version = parts(1)
            ElseIf parts(0) = "url" Then
                updateurl = parts(1)
            End If
        Next
        
        Dim versparts() As String
        versparts = Split(version, ".")
        
        If App.Major * 10000 + App.Minor * 1000 + App.Revision * 100 _
           < val(versparts(0)) * 10000 + val(versparts(1)) * 1000 + val(versparts(2)) * 100 Then
            'new version
            lblstatus.Caption = "New version available: " & version
            cmdUpdate.Enabled = True
            
        Else
            lblstatus.Caption = "No new updates available"
        End If
            
        imgarrow.Top = lblstatus.Top - 4
        DoEvents

End Sub

 'GetHTTPFile **************************************
'
' Return contents of an file from a given HTTP URL
'
' Requires: Reference to Internet Transfer control
'           Valid URL that returns textual data
'
' Author: Richard Bowman
' Date:   02/17/2005
'
Function GetHTTPFile(ctlInet As inet, ByVal sURL As String) As String
    ' cancel old operations
    ctlInet.Cancel
    ' set protocol to HTTP
    ctlInet.Protocol = icHTTP
    ' get the page
    GetHTTPFile = ctlInet.OpenURL(sURL)
End Function

Private Sub inet_StateChanged(ByVal State As Integer)
    If State = 3 Then
        imgarrow.Top = lblconnect.Top - 4
        DoEvents
    ElseIf State = 7 Then
        imgarrow.Top = lblRetrievingUpdateInfo.Top - 4
        DoEvents
    End If

End Sub

Sub HTTPDownloadFile(ByRef HTTP As inet, ByVal URL As String, ByVal LocalFileName As String)
    
    Dim Contents() As Byte

    With HTTP
        .Protocol = icHTTP
        .URL = URL
        Contents() = .OpenURL(.URL, icByteArray)
    End With
    Set HTTP = Nothing

    Open LocalFileName For Binary Access Write As #1
    Put #1, , Contents()
    Close #1
End Sub

