VERSION 5.00
Begin VB.Form frmConvToWallTile 
   BorderStyle     =   3  'Fixed Dialog
   Caption         =   "Convert to walltiles"
   ClientHeight    =   4395
   ClientLeft      =   45
   ClientTop       =   330
   ClientWidth     =   2250
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   293
   ScaleMode       =   3  'Pixel
   ScaleWidth      =   150
   ShowInTaskbar   =   0   'False
   StartUpPosition =   1  'CenterOwner
   Begin VB.CommandButton cmdCancel 
      Cancel          =   -1  'True
      Caption         =   "Cancel"
      Height          =   375
      Left            =   1200
      TabIndex        =   2
      Top             =   3960
      Width           =   975
   End
   Begin VB.CommandButton cmdOK 
      Caption         =   "Convert"
      Default         =   -1  'True
      Height          =   375
      Left            =   120
      TabIndex        =   1
      Top             =   3960
      Width           =   975
   End
   Begin VB.PictureBox picwalltiles 
      AutoRedraw      =   -1  'True
      BorderStyle     =   0  'None
      Height          =   3840
      Left            =   240
      ScaleHeight     =   256
      ScaleMode       =   3  'Pixel
      ScaleWidth      =   128
      TabIndex        =   0
      Top             =   0
      Width           =   1920
      Begin VB.Shape selwall 
         BorderColor     =   &H000000FF&
         Height          =   960
         Left            =   0
         Top             =   0
         Width           =   960
      End
   End
End
Attribute VB_Name = "frmConvToWallTile"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit
Dim parent As frmMain
Dim curwall As Integer

Sub setParent(main As frmMain)
    Set parent = main
End Sub

Private Sub cmdCancel_Click()
    Unload Me
End Sub

Private Sub cmdOK_Click()
    Call parent.sel.ConverttoWalltiles(parent.walltiles.curwall)
    Unload Me
End Sub

Private Sub Form_Activate()
    DoEvents
    DrawWallTiles
End Sub

Private Sub Form_Load()
    Set Me.Icon = frmGeneral.Icon

    cmdOK.Enabled = True
    selwall.Visible = True
    If parent.useWallTileLeft Then
        curwall = parent.curWallTileLeft
    ElseIf parent.useWallTileRight Then
        curwall = parent.curWallTileRight
    Else
        curwall = 0
    End If
    If Not parent.walltiles.isvalidset(curwall) Then
        Dim i As Integer
        For i = curwall To curwall + 7 Mod 8
            If parent.walltiles.isvalidset(i) Then
                curwall = i
                GoTo skip
            End If
        Next
        'No valid walltiles set found
        curwall = 0
        cmdOK.Enabled = False
        selwall.Visible = False
skip:
    End If
    selwall.Left = Int(curwall / 4) * 64
    selwall.Top = Int(curwall Mod 4) * 64

End Sub

Private Sub DrawWallTiles()
    Dim i As Integer
    For i = 0 To 7
        BitBlt picwalltiles.hdc, (i \ 4) * 4 * TileW, (i Mod 4) * 4 * TileW, 4 * TileW, 4 * TileW, parent.picwalltiles.hdc, i * 4 * TileW, 0, vbSrcCopy
    Next
    picwalltiles.refresh
End Sub


Private Sub Form_QueryUnload(Cancel As Integer, UnloadMode As Integer)
    Unload Me
End Sub

Private Sub picwalltiles_MouseDown(Button As Integer, Shift As Integer, x As Single, y As Single)
    Dim tmp As Integer

    tmp = (Int(x / (4 * TileW)) * 4) + Int(y / 64)

    If parent.walltiles.isvalidset(tmp) Then
        'New walltile selected
        curwall = tmp
        'Move the selection rectangle
        selwall.Left = Int(curwall / 4) * 64
        selwall.Top = Int(curwall Mod 4) * 64
    End If
End Sub
